function Console(par, pl)
{
    this.player = pl;
    this.btn = $(par.btn);
    this.input = $(par.inp);
    this.txt = $(par.log);
    this.history = new Array();
    this.oHistory = new Array();
    var exec = this.execute.bind(this);
    var keydown = keydownCons.bind(this);
    
    this.btn.click(function(){
        exec();
    });
    
    this.input.keydown(keydown);
}

function keydownCons(e)
{
    var e = e || window.event;
    var key = e.which;
        
    if (key == 38)
    {
        this.input.val(this.getHist());
    }
    
    if (key == 40)
    {
        this.input.val(this.getHistInv());
    }
    
    if (e.ctrlKey && key == 13)
    {
        this.input.val(this.input.val() + '---');
        
        return ;
    }
        
    if (key == 13)
    {
        this.btn.trigger('click');
    }
}

Console.prototype.log = function(str){
    var el = $('<div></div>').addClass('log').html(str.toString().trim()).click(showAllLog);
    
    this.txt.prepend(el);
};

function showAllLog()
{
    $(this).addClass('all');
}

Console.prototype.warn = function(str){
    var el = $('<div></div>').addClass('warn').html(str.toString().trim()).click(showAllLog);
    
    this.txt.prepend(el);
};

Console.prototype.error = function(str){
    var el = $('<div></div>').addClass('err').html(str.toString().trim()).click(showAllLog);
    
    this.txt.prepend(el);
};

Console.prototype.logAns = function(str){
    var el = $('<div></div>').addClass('log').html('> ' + str.toString().trim()).click(showAllLog);
    
    this.txt.prepend(el);
};

Console.prototype.warnAns = function(str){
    var el = $('<div></div>').addClass('warn').html('> ' + str.toString().trim()).click(showAllLog);
    
    this.txt.prepend(el);
};

Console.prototype.errorAns = function(str){
    var el = $('<div></div>').addClass('err').html('> ' + str.toString().trim()).click(showAllLog);
    
    this.txt.prepend(el);
};

Console.prototype.saveHist = function(txt){
    while(this.oHistory.length)
    {
        this.history.push(this.oHistory.shift());
    }
    
    this.history.push(txt);
};

Console.prototype.getHist = function(){
    var tmp = this.history.pop();
    if (!tmp || tmp.length < 3)
    {
        return '';
    }
    this.oHistory.unshift(tmp);
    
    return tmp;  
};

Console.prototype.getHistInv = function(){
    var tmp = this.oHistory.shift();
    if (!tmp || tmp.length < 3)
    {
        return '';
    }
    this.history.push(tmp);
    
    return tmp;  
};

Console.prototype.execute = function(){
    var txt = this.input.val().trim();
    
    if (txt === '')
    {
        return ;
    }
    
    
    if (txt === 'getHistory')
    {
		this.input.val('');
		
	    var string = '';
	    
	    if(this.history.length > 0){
		    var historyLength = this.history.length;
		    
		    for(var i = 0; i < historyLength; ++i){
			    console.log(this.history[i] + '---');
			    if(this.history[i] != undefined)
		    		string += this.history[i] + '---';
		    }
			string = string.slice(0,-3);
	    }
	    	
	    if(this.history.length == 0)
	    	string = 'History is empty';
	    	
	    alert(string);

	    return 0;
    }
    
    this.log(txt);
    
    if(!this.player.parse(txt))
    {
        this.input.val('');
        
        this.saveHist(txt);
    }
    else
    {
        this.warnAns('Can not disassemble');
    }
};