function Coor(e, y)
{
    if (e.pageX)
    {
        this.x = e.pageX;
        this.y = e.pageY;
        
        return ;
    }
    if (typeof e == 'number')
    {
        this.x = e;
        this.y = y;
        
        return ;
    }
    else
    {
        this.x = e.x;
        this.y = e.y;
        
        return ;
    }
}

function createHTMLTable(id, numberOfCellsPerRow, numberOfRows, cellWidth, cellHeight)
{
	var generatedHTMLTable = '<style>    \
		#table' + id + '.show{}        \
		#table' + id + '.hide{display:none;}     \
		#table' + id + '{display:table;position:fixed;width: 2000px;height:1000px;top:27px;border-collapse:collapse;left:0px;z-index:1;outline:2px solid gray;}   \
		#table' + id + ' > div{display:table-row;}                                                \
		#table' + id + ' > div > div{display:table-cell;width:' + cellWidth + 'px;height:' + cellHeight + 'px;outline:1px solid white;}    \
		</style>';
	for(var ii = 0; ii < numberOfRows; ++ii)
	{
		generatedHTMLTable += "<div>";
		
		for(var i = 0; i < numberOfCellsPerRow; ++i)
		{
			generatedHTMLTable += "<div></div>";
		}
		
		generatedHTMLTable += "</div>";
	}
	                                              
	var tableDiv = $('<div id="table'+id+'" class="show" data-type="grid">'+generatedHTMLTable+'</div>')
	
	$('body').append(tableDiv);
}

function colorHTMLTableCell(id, numberOfRows, numberOfCell)
{
  	var fix = 1;
  	var rowBefore = Math.floor((fix + numberOfCell) / numberOfRows);
	var styleToColorDiv = $('<style>#table' + id + ' > div:nth-child(' + (rowBefore + 1 + fix) + ') > div:nth-child(' + (0 + Math.floor(fix + numberOfCell - rowBefore * numberOfRows)) +'){outline:3px dashed dodgerblue;}</style>');
	$('#table' + id).append(styleToColorDiv);
}


Coor.prototype.toString = function(type){
    return JSON.stringify(this);
}

Coor.prototype.plus = function(B){
    this.x += B.x;
    this.y += B.y;
    
    return this;
}

Coor.prototype.isNaN = function(){
    if (isNaN(this.x) || isNaN(this.y))
        return 1;
    return 0;
}

function dot(A, B)
{
    return (A.x * B.x + A.y * B.y);
}

function length(A, B)
{
    return Math.sqrt((A.x - B.x)*(A.x - B.x) + (A.y - B.y)*(A.y - B.y));
}

function sign(x)
{
    return (x > 0 ? 1 : x < 0 ? -1 : 0);
}
 
function Vector(A, B)
{
    this.begin = A;
    this.end = B;
    this.length = length(A, B);
}

Vector.prototype.midX = function(){
    return (this.begin.x + this.end.x)/2;
}


Vector.prototype.midY = function(){
    return (this.begin.y + this.end.y)/2;
}

Vector.prototype.toString = function(type){
    if (type === 'full')
    {
        return JSON.stringify(this, null, 4)
    }
    else
    {
        return JSON.stringify(this, [   
                                        'begin',
                                        'end',
                                        'length',
                                        'x',
                                        'y',
                                ], 4)
    }
}

Vector.prototype.resize = function(){
    this.length = length(A, B);
}

Vector.prototype.plus = function(B){
    this.begin.plus(B.begin);
    this.end.plus(B.end);
    this.resize();
    
    return this;
}

function plusVector(A, B)
{
    return new Vector(plusCoor(A.begin, B.begin), plusCoor(A.end, B.end));
}

function plusCoor(A, B)
{
    return new Coor(A.x + B.x, A.y + B.y);
}
          
function minusCoor(A, B)
{
    return new Coor(A.x - B.x, A.y - B.y);
}

function timesCoor(e, k)
{
    return new Coor(k * e.x, k * e.y);
}    
function deltaCoor(e)
{
    return Math.sqrt(dot(e,e));
} 

function setCoorLink(a, b, length)
{
  	
    this.el.css('top', a.y);
    this.el.css('left', a.x);
	this.el.css('height', length);
	var angle = 0;
  	var deltaX = b.x - a.x;
  	var deltaY = b.y - a.y;
  
  	if (deltaX == 0)
		angle = ((deltaY > 0) - (deltaY < 0)) * Math.PI / 2;
	else
        if(deltaX < 0) 
        	angle = ((deltaY >= 0) - (deltaY < 0)) * Math.PI + Math.atan(deltaY / deltaX);
        else angle = Math.atan(deltaY / deltaX);

   angle -= Math.PI/2;
   this.el.css('transform', 'rotate(' + angle + 'rad)');
}
