function parse(str)
{
    var lines = str.trim().split('---');
    var line;
    var state = 0;
    
    while (lines.length)
    {
        line = lines.shift().trim();
        
        lineTokens = line.split(' ');
        cmdToken = lineTokens.shift();
    
        if(this[cmdToken])
        {
            state = state | this[cmdToken].apply(this, lineTokens);
// log
            console.log(cmdToken+'  '+lineTokens);
        }
        else
        {
            this.player.console.errorAns('Command can`t be found: ' + cmdToken);
            state = 1;
        }
    }
    
    return state;
}

function Parser(pl)
{
    this.player = pl;
    
    return this;   
}

Parser.prototype.log = function(str){
    this.player.console.logAns(str);
}

Parser.prototype.warn = function(str){
    this.player.console.warnAns(str);
}

Parser.prototype.error = function(str){
    this.player.console.errorAns(str);
}

Parser.prototype.$$ = function(){
	var arr = Array.prototype.join.call(arguments, ' ');
    this.log('<div class="com">' + arr + '</div>');
}

Parser.prototype.parse = parse;

Parser.prototype.addPoint = function(coor, vel, radius, mass)
{
	mass = mass || 5;
	radius = radius || 50;
	if(vel)
		parsedOldCoor = minusCoor(parseCoor(coor), parseCoor(vel));
	else
		parsedOldCoor = parseCoor(coor);
		
    this.player.addPoint(parseFloat(mass), parseFloat(radius), parseCoor(coor), parsedOldCoor);
    
    return 0;
}

Parser.prototype.addWall = function(vectM, vectO)
{
    this.player.addWall(parseVector(vectM), parseVector(vectO));
    
    return 0;
}

Parser.prototype.setProp = function(id, vrS, valS){
    var vr, val = valS, type = 'point';
    
    switch(vrS)
    {
        case 'mass': vr = 'invmass'; val = 1 / valS; break;
        case 'invmass': vr = 'invmass'; break;
        case 'radius': vr = 'radius'; break;
        //case 'isExpToPot': vr = 'ExpToPot'; break;
        default: vr = vrS;
    }
    
    id = id.match(/#(\d+)/)[1];
    
    try{
        var el = this.player.find(id);
        if (!el)
        {
            throw new Error('Can`t find element.');
        }
        
        if (el.type != type)
        {
            throw new Error('Wrong type of element: ' + el.type + ' != ' + type);
        }
        
        if (!(vr in el))
        {
            throw new Error('Variable does not exist: ' + vr);
        }
        
        el[vr] = val;
        
    }
    catch(e)
    {
        this.error(e.message);
        return 1;
    }
    
    this.log('Set.');
    
    return 0;
}

Parser.prototype.gravity = function(flagOrVal){
    if (flagOrVal === 'disable')
    {
        player.physics.G = new Coor(0, 0);
    }
    else
    {
        player.physics.G = parseCoor(flagOrVal);
    }
    this.log('Set.');
}

Parser.prototype.addStick = function(elem1, elem2){
    var l1, l2;
    
	l1 = parseElem(elem1.match(/#(\d+)/)[1]);
	l2 = parseElem(elem2.match(/#(\d+)/)[1]);

    this.player.addStick({
        'el': l1,
        'coor': l1.coor
    }, {
        'el': l2,
        'coor': l2.coor
    });
    
    return 0;
}

Parser.prototype.stop = function(){
    this.player.stop();
    
    return 0;
}


Parser.prototype.play = function(){
    this.player.play();
    
    return 0;
}


Parser.prototype.step = function(st){
    this.player.nextStep(st);
    
    return 0;
}

Parser.prototype.getInfo = function(){
    this.player.getInfo();
    
    return 0;
}

Parser.prototype.execute = function()
{
    var cmd = Array.prototype.join.call(arguments, ' ');
    
    try{
        this.log(eval(cmd));
    }
    catch(e)
    {
        this.error(e.name + '. '+ e.message);
    }
    
    return 0;
}

Parser.prototype.showGrid = function(xyOrType, nOfType){
    if (xyOrType === 'type')
    {
        switch(nOfType)
        {
            case '0': this.showGrid('100x50'); break;
            case '1': this.showGrid('50x25'); break;
            case '2': this.showGrid('20x10'); break;
            default: this.warn('Type of table does not exist.');
        }
        
        return 0;
    }
    
    var xy = xyOrType;
    var id = xy;
    
    this.hideGrid('all');
    var el = $('#table'+id);
    
    if (!el.length)
    {
        var arr = xy.split('x');
        var x = +arr[0];
        var y = +arr[1];
        var nx = 2000 / x;
        var ny = 1000 / y;

        createHTMLTable(id, nx, ny, x, y);
// log
        this.log('Table ' + xy + ' created.')
    }
    else
    {
        el.show();
// log
        this.warn('Table already exists');
    }
    return 0;
};

Parser.prototype.hideGrid = function(allOrId)
{
    if (allOrId === 'all' || !allOrId)
    {
        $('div[data-type=grid]').hide();
    }
    else
    {
        $('#table'+allOrId).hide();
    }
}

Parser.prototype.addSpring = function(elem1, elem2, c){
    var l1, l2;
  	c = c || 5;
    
	l1 = parseElem(elem1.match(/#(\d+)/)[1]);
	l2 = parseElem(elem2.match(/#(\d+)/)[1]);

    this.player.addSpring({
        'el': l1,
        'coor': l1.coor
    }, {
        'el': l2,
        'coor': l2.coor
    }, parseFloat(c));
    
    return 0;
}

Parser.prototype.changeSpring = function(id, c){
    var el = this.player.renderer.arr[id.match(/#(\d+)/)[1]].ptr;
    
    if(el.type == 'spring'){
	    el.k_ = c;
		this.log('Set new stiffness.');
    }
	else{
		this.error('Wrong type.');
	}
    
    return 0;
}

Parser.prototype.changeSprings = function(kStr){
    var k = kStr.split('->');
    var kOld = k[0];
    var kNew = k[1];
	this.player.physics.Springs.forEach(function(val){
        if (kOld == 'all' || val.k_ == kOld)
            val.k_ = kNew;
    });
    
    return 0;
}


Parser.prototype.clrscr = function(){
    this.player.console.txt.empty();
    
    return 0;
}

Parser.prototype.setVelocity = function(id, velocity){
    var v = parseCoor(velocity);
    
    var el = this.player.renderer.arr[id.match(/#(\d+)/)[1]].ptr;
    
    if(el.type == 'point'){
	    el.oldCoor = minusCoor(el.coor, v);
		this.log('Set new velocity.');
    }
	else{
		this.error('Wrong type.');
	}
    
    return 0;
}

Parser.prototype.movePoint = function(id, coorXY, saveVelocity){
  	if(saveVelocity == 'saveV')
    	this.player.renderer.arr[id.match(/#(\d+)/)[1]].ptr.move(parseCoor(coorXY));
  	else
		this.player.renderer.arr[id.match(/#(\d+)/)[1]].ptr.moveEase(parseCoor(coorXY));
  	this.log('Moved.');
}

function parseCoor(c)
{
    var t = c.replace(/\(/g, '').replace(/\)/g, '').split(',');
    
    return new Coor(parseInt(t[0]), parseInt(t[1]));
}

function parseVector(c)
{
    var t = c.replace(new RegExp('{', 'g'), '').replace(new RegExp('}', 'g'), '').split(';');
    
    return new Vector(parseCoor(t[0]), parseCoor(t[1]));
}

function parseElem(c)
{
    return this.player.renderer.arr[c].ptr;
}