var step;

function Player(dt, phys, render, console)
{
    this.tick = 0;
    this.dt = dt;
    this.tickCount = 0;
    this.physics = new Physics(phys, this);
    this.renderer = new Renderer(render, this);
    this.parser = new Parser(this);
    this.console = new Console(console, this);
    var checker = checkerPl.bind(this);
    
    this.stop = function(){
        clearTimeout(this.tick);
        this.tick = 0;
        
// log
        this.console.logAns('Pause...');
    }
    
    this.play = function(){
        if (!this.tick)
        {
            this.tick = setTimeout(function stepTm(pl){
                step(pl, checker);
                pl.tick = setTimeout(stepTm, pl.dt, pl);
            }, this.dt, this);
// log
            this.console.logAns('Play');
        }
    }
    
    this.shifter = function(){
        if (this.tick)
        {
            this.stop();
            
            return 0;
        }
        else
        {
            this.play();
          	
            return 1;
        }
    }
    
    this.nextStep = function(i){
        if (!i)
        {
            step(this, checker);
// log
            this.console.logAns('step');
        }
        else
        {
            this.console.logAns('step x ' + i);
            
            while (i--)
            {
                step(this, checker);
            }
        }
        
    }
    
    this.getInfo = function(){
        this.console.logAns('Tick count: '+this.tickCount);
        this.console.logAns('Points count: '+this.physics.Points.length);
        this.console.logAns('Walls count: '+this.physics.Walls.length);
        this.console.logAns('Springs count: '+this.physics.Springs.length);
        this.console.logAns('Sticks count: '+this.physics.Sticks.length);
    }
    
    this.find = function(id){
        if (id in this.renderer.arr)
        {
            return this.renderer.arr[id].ptr;
        }
        
        return 0;
    }
    
    this.addPoint = function(mass, radius, coorXY, oldCoorXY, isExpToPot){
        var tmp = this.physics.addPoint(mass, radius, coorXY, oldCoorXY, isExpToPot);
        this.renderer.addPoint(tmp);
// log
        this.console.logAns('Create point.');
    }
    
    this.addWall = function(vectM, vectO){
        var tmp = this.physics.addWall(vectM, vectO);
        this.renderer.addWall(tmp);
// log
        this.console.logAns('Create wall.');
    }
    
    this.addStick = function(elem1, elem2){
        var tmp = this.physics.addStick(elem1, elem2);
        this.renderer.addStick(tmp);
// log
        this.console.logAns('Create stick.');
    }
    
    this.addSpring = function(elem1, elem2, k){
        var tmp = this.physics.addSpring(elem1, elem2, k);
        this.renderer.addSpring(tmp);
// log
        this.console.logAns('Create spring.');
    }
    
    this.parse = function(str){
        return this.parser.parse(str);
    }
    
    this.log = function(str){
        this.console.log(str);
    }
    
    this.warn = function(str){
        this.console.warn(str);
    }
    
    this.error = function(str){
        this.console.error(str);
    }
}      

step = function(pl, checker){
    if (!checker())
    {
        pl.physics.step();
        pl.renderer.draw();
        pl.tickCount++;
    }
    else
    {
        pl.stop();
        checker('delete');
    }  
}   

function checkerPl(mode, vr, val)
{
    var st = checkerPl.state;
    
    if (arguments.length == 0) // check
    {
        for (var i in st)
        {
            if (player[st[i].vr] < st[i].val)
            {
                return 1;
            }
        }
        
        return 0;
    }
    
    if (mode == 'delete') // delete
    {
        for (var i in st)
        {
            if (player[st[i].vr] < st[i].val)
            {
                delete st[i];
            }
        }
        
        return 0;
    }
    
    if (mode == 'add') // add
    {
        st.push({'vr': vr, 'val': val});
        
        return 0;
    }
}

