function Renderer(param, pl)
{
    this.scr = $('#'+param.idEl);
    this.borderSize = param.borderSize;
    this.arr = new Array();
    this.player = pl;
}

Renderer.prototype.addPoint = function(point){   
    var el = $('<div data-id="'+point.id+'" class="point"></div>');
    el.css('width', 2 * point.radius - 2 * this.borderSize);
    el.css('height', 2 * point.radius - 2 * this.borderSize);
    el.css('border-radius', 2 * point.radius - 2 * this.borderSize);
  	el.css('font-size', 10 * (point.radius - this.borderSize) + '%');
    this.scr.append(el);
    
    var tmp = {
        'el': el,
        'ptr': point,
        'draw': function(){
                var c = this.patch(this.ptr.coor);
                this.el.css('top', c.y);
                this.el.css('left', c.x);
        },
        'setCoor': function(c){
                c = c || this.patch(this.ptr.coor);
                this.el.css('top', c.y);
                this.el.css('left', c.x);
        },
        'patch': function(c){
            return new Coor(c.x - this.ptr.radius, c.y - this.ptr.radius);
        },
        'patchC': function(c){
            return new Coor(c.x + this.ptr.radius, c.y + this.ptr.radius);
        }
    };
    this.arr[point.id] = tmp;
    
    tmp.setCoor();
}


Renderer.prototype.log = function(str){
    this.player.log(str);
}


Renderer.prototype.warn = function(str){
    this.player.warn(str);
}


Renderer.prototype.error = function(str){
    this.player.error(str);
}


Renderer.prototype.addWall = function(wall){
    var el = $('<div data-id="'+wall.id+'" class="wall"></div>');
    el.css('left', wall.main_.midX());
    el.css('top', wall.main_.midY())
    this.scr.append(el);
    
    var tmp = {
        'el': el,
        'ptr': wall
    }
    
    this.arr[wall.id] = tmp;
}

Renderer.prototype.addStick = function(stick){
    var el = $('<div data-id="'+stick.id+'" class="stick"></div>');
    this.scr.append(el);
    
    var tmp = {
        'el': el,
        'ptr': stick,
        'setCoor': function(b, e, l){
            setCoorLink.call(this, b, e, l);
        },
        'draw': function(){
            this.setCoor(this.ptr.coorB, this.ptr.coorE, this.ptr.length_);
        }
    };

    this.arr[stick.id] = tmp;
}

Renderer.prototype.addSpring = function(spring){
    var el = $('<div data-id="'+spring.id+'" class="spring"></div>');
    this.scr.append(el);
    
    var tmp = {
        'el': el,
        'ptr': spring,
        'setCoor': function(b, e, l){
            setCoorLink.call(this, b, e, l);
        },
        'draw': function(){
            if (this.ptr.k == 0)
            {
                this.el.hide();
                delete this.draw;
            }
            else
            {
                this.setCoor(this.ptr.coorB, this.ptr.coorE, length(this.ptr.coorB, this.ptr.coorE));
            }
        }
    };

    this.arr[spring.id] = tmp;
}

Renderer.prototype.draw = function(){
    for (var key in this.arr)
    {
        var l = this.arr[key];
        
        if (l.draw)
        {
            l.draw();            
        }

    }
}
